#ifndef __ARRAY__
#define __ARRAY__

#define DEBUG

#define bGarbage 0xCC
#define MIN(A,B) (((A)<(B))?(A):(B))

#include <alloc.h>
#include <dos.h>
#include <mem.h>
#include <assert.h>
#include <string.h>
#include "Point2d.hpp"

class ArrayP2d {

	private:
		Point2d *pt;
		char* str_class_name;
		unsigned int allocated_objects;
		unsigned int i_delta;
		unsigned int n_objects;
		unsigned int u_start_array_size;

	public:
		ArrayP2d(unsigned int u_array_size, int u_deltaVal, char* str_class_name);
		~ArrayP2d();
		Point2d& operator[] (unsigned int i);         // NON-CONSTANT []
		ArrayP2d& operator = (ArrayP2d& at);
		void Print(void);
		void AddNext(Point2d& t);
		void ReplaceAt(Point2d& t, unsigned int i_at);
		void InsertAt(Point2d& t, unsigned int i_at);
		void DeleteAt(unsigned int i_at);
		void Clear(void);
		inline unsigned int Count(void) { return n_objects; }
		int IsInArray(Point2d& p);

	private:
		void SetSize(long new_allocated_objects);

};


#endif