#include <math.h>
#include "Point2d.hpp"


Point2d::Point2d(void) {
	x = 0;
	y = 0;
}

Point2d::Point2d (int cx, int cy) {
	x = cx;
	y = cy;
}

Point2d& Point2d::operator = (Point2d & p) {
	x = p.x;
	y = p.y;
	return (* this);
}

/*
Point2d Point2d::operator = (float n) {
	 x = n;
	 y = n;
	 z = n;
   return (* this);
}
*/

Point2d Point2d::operator + (Point2d & p) {
	Point2d aux;

	aux.x = x + p.x;
	aux.y = y + p.y;
	return aux;
}

/*
Point2d Point2d :: operator + (float n)
{
	 Point2d aux;

   aux.x = x + n;
	 aux.y = y + n;
   aux.z = z + n;
   return aux;
}
*/


Point2d Point2d::operator - () {
	Point2d aux;

	aux.x = - x;
	aux.y = - y;
	return aux;
}

Point2d Point2d :: operator - (Point2d& p) {
	Point2d aux;

	aux.x = x - p.x;
	aux.y = y - p.y;
	return aux;
}

/*
Point2d Point2d :: operator - (float n) {
	 Point2d aux;

   aux.x = x - n;
   aux.y = y - n;
   aux.z = z - n;
   return aux;
}
*/

/*
Point2d Point2d::operator * (Point2d& p) {
	Point2d aux;

	aux.x = x * v.x;
	aux.y = y * v.y;
	return aux;
}
*/


Point2d Point2d::operator * (float n) {
	Point2d aux;

	aux.x = x * n;
	aux.y = y * n;
	return aux;
}


Point2d Point2d::operator / (float n) {
	Point2d aux;

	aux.x = x / n;
	aux.y = y / n;
	return aux;
}

/*
Point2d Point2d :: operator / (Point2d & v)
{
	 Point2d aux;

	 aux.x = x / v.x;
	 aux.y = y / v.y;
	 aux.z = z / v.z;
	 return aux;
}
*/


/*
int Point2d::operator > (float r) {
	 return ((x > r) || (y > r) || (z > r));
}
*/

/*
float Point2d::operator | (Point2d& p) {
	 return x * p.x + y * p.y;
}
*/


/*
// prod vectorial

Point2d Point2d :: operator & (Point2d & v)
{
	 Point2d aux;

	 aux.x = y * v.z - z * v.y;
	 aux.y = z * v.x - x * v.z;
	 aux.z = x * v.y - y * v.x;
	 return aux;
}
*/


/*
// Ŀ
//   Sobrecarga del operador not, que pasa a sig-  
//   nificar 'normalizar Point2d'.                 
// 

Point2d Point2d :: operator ! ()
{
	 Point2d aux;
	 float modulo;

	 // El modulo del Point2d es la raiz cuadrada
	 //		de su producto escalar

	 modulo = sqrt (* this | * this);
	 aux = * this;

	 // Si el mdulo no es aproximadamente 1 y
			es mayor que 0, divide

	 if ((modulo > 1 + EPSILON) ||
			((modulo < 1 - EPSILON) && (modulo > EPSILON)))
	 {
		 aux.x = x / modulo;
		 aux.y = y / modulo;
		 aux.z = z / modulo;
	 }

	 return aux;
}
*/

/*
void Point2d :: como_mucho (float max)
{
	 if (x > max)
			x = max;
	 if (x < -max)
			x = -max;

	 if (y > max)
			y = max;
	 if (y < -max)
			y = -max;

	 if (z > max)
			z = max;
	 if (z < -max)
			z = -max;
}
*/


/* Ŀ
	   Devuelve la coordenada dominante del Point2d   
	   (la que tiene mayor valor absoluto).          
	 

int Point2d :: dominante ()
{
	 float aux1, aux2;
	 int  i;

	 aux1 = ABS(x);
	 aux2 = ABS(y);
	 if (aux1 > aux2)
	 {
			if (aux1 > ABS(z))
	 i = 0;
			else
	 i = 2;
	 }
	 else
	 {
			if (aux2 > ABS(z))
	 i = 1;
			else
	 i = 2;
	 }

	 return i;
}
*/


/* Ŀ
     Comprueba si hay alguna componente positiva.  
   

int Point2d :: alguno_positivo ()
{
	 return ((x > EPSILON) || (y > EPSILON) || (z > EPSILON));
}

float Point2d::mod(void) {
	como_mucho(500000);
	return sqrt (* this | * this);

}
*/


/*
void Point2d :: normaliza(void) {
	*this = *this / mod();
}
*/


int Point2d::operator == (const Point2d& p) {
	return (p.x==x && p.y==y);
}

float Point2d::mod(void) {
	return sqrt((float)x*(float)x + (float)y*(float)y);
}
