#ifndef __SEGMENT__
#define __SEGMENT__

#include "Vector.hpp"
#include "Point2d.hpp"
#include <graphics.h>


class Segment {
	public:
		Vector  p1,p2;   // segment defined by two points  p1 and p2

		Segment(void) {}
		Segment(Vector& p1Val, Vector& p2Val) { p1=p1Val; p2=p2Val; }
		Segment(Point2d& p1Val, Point2d& p2Val) {
			p1.x=p1Val.x; p1.y=p1Val.y;
			p2.x=p2Val.x; p2.y=p2Val.y;
		}

		Segment operator = (Segment& s);

		float Distance2(Vector& point); // distance square
		float Distance(Vector& point);  // sqrt of Distance2()
		Vector GetNearestPoint(Vector& point);
		int  Intersect(Segment& seg, Vector* v_result);
		void Draw(void) { line(p1.x, p1.y, p2.x,p2.y); }
		void Print(void) { printf("(%f,%f_%f,%f)", p1.x,p1.y, p2.x,p2.y); }
		int  IsInSegment(Vector& p);
		int  AreInSameSide(Point2d& p1, Point2d& p2);

	private:
		int Intersect_type_YY(double m1, double c1, double m2, double c2, Vector* v_result);
		int Intersect_type_YX(double m1, double c1, double m2, double c2, Vector* v_result);
		void Get_m_c_type(Segment& seg, double& m, double& c, int& type);

};


#endif